/*  cv graph.cpp maxflow.cpp graph.h block.h alpha_stereo.cpp -o alpha_stereo */

#define _DEBUG
//#undef _DEBUG


#include <stdio.h>
#include<stdlib.h>
#include "graph.h"
#include<cv.h>
#include<highgui.h>
#include<cxcore.h>
#include<vector>
#include<time.h>

#define COST 1
#define HOGE COST
#define AREGION 255
#define BREGION 0

#define CONST 1
#define E 999999999

#define HIDARI 0
#define UE 1
#define MIGI 2
#define SHITA 3

#define LEFT 4
#define RIGHT 5


#define B 0
#define G 1
#define R 2

#define WINSIZE 3
#define sqr(a) ( (a)*(a) )
#define TH 255


using namespace std;

typedef unsigned char uchar;
int moro_height;
int moro_width ;
IplImage* src1;//left
IplImage* src2;//right

typedef struct color{

  unsigned char b;
  unsigned char g;
  unsigned char r;

}COLOR;

/**************************************************************************/
/*(x,y)BGRlԂ(color 0:B 1:G 2:R)*/
/**************************************************************************/

unsigned char getColor(IplImage *img,int color,int x,int y)
{

  return  ((unsigned char*)(img->imageData + img->widthStep * y))[x*img->nChannels + color];

}

COLOR getColorBGR(IplImage *img,int x,int y)
{
  COLOR c;

  c.b = getColor(img,B,x,y);

  c.g = getColor(img,G,x,y);

  c.r = getColor(img,R,x,y);

  return c;

}

////////////////////////////////////////////////////////////////////////////////
/* f[^RXg֐ */
////////////////////////////////////////////////////////////////////////////////

int d_cost(int x, int y, int disp){

  int sum = 0;
  int count = 0;

  for(int i = -WINSIZE; i <= WINSIZE; i++){
    for(int j = -WINSIZE; j <= WINSIZE; j++){
      if( ((x +j) > moro_width) || ((x +j) < 0) ){continue;}
      if( ((y +i) > moro_height) || ((y +i) < 0) ){continue;}
      count++;

	sum += abs(

		   ((uchar*)(src1->imageData+src1->widthStep*(y+i)))[(x+j)*3] - ((uchar*)(src2->imageData+src2->widthStep*(y+i)))[(x+j-disp)*3]
		   +
		   ((uchar*)(src1->imageData+src1->widthStep*(y+i)))[(x+j)*3+1] - ((uchar*)(src2->imageData+src2->widthStep*(y+i)))[(x+j-disp)*3+1]
		   +
		   ((uchar*)(src1->imageData+src1->widthStep*(y+i)))[(x+j)*3+2] - ((uchar*)(src2->imageData+src2->widthStep*(y+i)))[(x+j-disp)*3+2]

		   ) / 3;


    }

  }

  return sum / count;
}

////////////////////////////////////////////////////////////////////////////////
/* X[YRXg֐ */
////////////////////////////////////////////////////////////////////////////////

inline int s_cost(uchar p, uchar q, double c){//X[YRXg

  return (int)( c * abs( int(p - q) ) );

}

////////////////////////////////////////////////////////////////////////////////
/* f̃m[hʒuQ */
////////////////////////////////////////////////////////////////////////////////

inline int pixelIdx(int x, int y){//f̍WnodeIdx擾

  return ( (3*moro_width-1)* y ) + ( 2 * x ); 

}

////////////////////////////////////////////////////////////////////////////////
/* אډfQ */
////////////////////////////////////////////////////////////////////////////////

inline int pixelneighbor(int x, int y, int d){
  /* dŎwf̂ǂ̕ɂnodeIdx߂lƂ邩w肷*/
  /* 0:C1:C2:EC3:*/

  switch(d){
  case 0:
    return ( pixelIdx(x,y)-1 );
    break;
  case 1:
    return ( pixelIdx(x,y) - (moro_width + x));
    break;
  case 2:
    return ( pixelIdx(x,y)+1 );
    break;
  case 3:
    return ( pixelIdx(x,y) + ((2*moro_width-1) - x) );
    break;
  default:
    return -1;
    break;
  }

}


////////////////////////////////////////////////////////////////////////////////
/* C֐ */
////////////////////////////////////////////////////////////////////////////////

int main(int argc, char* argv[])
{

  clock_t start,end;


  /**/
  /*./alpha_stereo 摜@E摜@o͉摜@ő压*/

  if(argc != 5){
    fprintf(stderr,"%d\n",argc);
    fprintf(stderr,"%s input1_filename input2_filename output_filename max_disp\n",argv[0]);
    return -1;
  }


  /*摜̓ǂݍ*/
  //src1 = cvLoadImage(argv[1],CV_LOAD_IMAGE_GRAYSCALE);//left
  src1 = cvLoadImage(argv[1],CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);//left
  if(src1 == NULL){
    fprintf(stderr,"Input left error.\n");
    return -1;
  }
  //src2 = cvLoadImage(argv[2],CV_LOAD_IMAGE_GRAYSCALE);//right
  src2 = cvLoadImage(argv[2],CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);//right
  if(src2 == NULL){
    fprintf(stderr,"Input right error.\n");
    return -1;
  }

  int dispMax = atoi(argv[4]);//ő压

  /* GbW摜̏o */



  /*摜̕C̎w*/
  int height = src1->height;
  int width = src1->width;
  moro_height = src1->height;
  moro_width = src1->width;

  /*GbWCm[h̐*/
  int edge_num = ((height-1) *(width)) + ((height) * (width-1)) * 2;
  int node_num =  (width * height) 
    + ((width-1) * (height)) 
    + ((width) * (height-1));

  typedef Graph<int,int,int> GraphType;


  int f[width * height];/*ʂ*/


  /////////////////////////////////////////////////////////////////////////////////////
  //
  //                                         
  //
  //
  //
  //
  //
  //       OtJbgJn(EoE)~
  //
  //
  //
  //
  //
  //
  //
  ////////////////////////////////////////////////////////////////////////////////////


  start = clock();

  fprintf(stderr,"matching...\n");

  for(int p = 0; p < width * height; p++){//f̏lݒ

    //    f[p] = src1->imageData[p];
    f[p] = 0;
  }


  long int e = E;
  int success = 0;
 


  double moro_c;
  int d;
  for(int n = 0; n < 1; n++){

    success = 0;

    for(int alpha = -320; alpha <= dispMax; alpha++){//alpha̒l015ŉ
      //for(int alpha = 0; alpha < 256; alpha++){//alpha̒l016ŉ

      GraphType *g = new GraphType( node_num,  edge_num );//Ot̏

      g -> add_node(node_num);//m[h̒ǉ 

      /*m[hƃ\[XEVNւ̏d݂̐ݒ*/
      for(int j = 0; j < height; j++){
	for(int i = 0; i < width; i++){

	  int gaso_num = i + width*j;//fWɑΉꎟzIdx
	  int tmp_num = pixelIdx(i,j);//fWɑΉnodeIdx擾

	      /*f[^RXgݒ*/
	      g -> add_tweights( tmp_num,d_cost(i,j,f[gaso_num]), 
				 d_cost(i,j,alpha) );
    

	}

      }



      int omomi = 0;

      /*GbW̏d݂ݒ*/
      for(int j = 0; j < height; j++){
	for(int i = 0; i < width; i++){



	  if( i != (width-1) ){//E[͉Eւ̃GbW݂Ȃ

	    int fpalpha = s_cost(f[i+j*width] , alpha , 1);
	    int fqalpha = s_cost(f[i+j*width + 1] , alpha , 1);


	    g -> add_edge( pixelIdx(i ,j),pixelneighbor(i,j,MIGI), fpalpha, fpalpha);
	    g -> add_edge( pixelneighbor(i,j,MIGI), pixelIdx(i+1 ,j), fqalpha, fqalpha);

	    //ԃm[h̃VNƃ\[Xւ̃RXgݒiEj
	    //\[XFV(fp,fq(̉f))
	    //VNFV(alpha,alpha)
	    g -> add_tweights( pixelneighbor(i,j,MIGI),
			       s_cost(f[i+j*width],f[i+j*width +1],moro_c), 
			       s_cost(alpha,alpha,moro_c) );

	  }




	  if( j != (height-1) ){//[͉ւ̃GbW݂Ȃ


	    int fpalpha = s_cost(f[i+j*width] , alpha , 1);
	    int fqalpha = s_cost(f[i+(j+1)*width] , alpha , 1);

	    g -> add_edge( pixelIdx(i ,j),pixelneighbor(i,j,SHITA), fpalpha, fpalpha);
	    g -> add_edge( pixelneighbor(i,j,SHITA), pixelIdx(i ,j +1), fqalpha , fqalpha );



	    //ԃm[h̃VNƃ\[Xւ̃RXgݒij
	    //\[XFV(fp,fq(̉f))
	    //VNFV(alpha,alpha)
	    g -> add_tweights( pixelneighbor(i,j,SHITA),
			       s_cost(f[i+j*width],f[i+(j+1)*width],moro_c), 
			       s_cost(alpha,alpha,moro_c) );


	  }






	}
      }



      int flow = g -> maxflow();//ő嗬EŏJbgASYKp
      //fprintf(stderr,"disp = %d  Flow = %d\n", alpha,flow);

      if(flow < e){
	//fprintf(stderr,"Alpha = %d  Flow = %d\n", alpha,flow);

	/*݂̃x܂x֕ύX*/
	for(int k =0; k < height ; k++){
	  for(int m =0; m < width ; m++){

	    int gaso_num = m + width*k;//fWɑΉꎟzIdx
	    int tmp_num = pixelIdx(m,k);//fWɑΉnodeIdx擾

	    if (g->what_segment(tmp_num) == GraphType::SOURCE){

	      //if(m ==  && )fprintf()

	      f[gaso_num] = alpha;//xalphaɕύX

	    }else{

	      //ύXȂ

	    }

	  }

	}

	e = flow;
	success = 1;

      }
      delete g;




    }

    fprintf(stderr,"roop = %d\n", n);
    if(success == 0){

      break;

    }

  }



  end =clock();
  fprintf(stderr,"%f sec\n",(double)(end-start)/CLOCKS_PER_SEC);


  /*摜o*/
  IplImage* output;
  output = cvCreateImage(cvGetSize(src1),IPL_DEPTH_8U,1);

  for(int y = 0; y < output->height; y++){

    for(int x = 0 ; x < output->width ; x++){

      ((uchar*)(output->imageData + output->widthStep * y))[x] = (int)(f[y*output->width+x] * 255.0 / dispMax);

    }

  }



#ifdef _DEBUG
  cvNamedWindow("output",CV_WINDOW_AUTOSIZE);
  cvShowImage("output",output);
  cvNamedWindow("input-left",CV_WINDOW_AUTOSIZE);
  cvShowImage("input-left",src1);
  cvNamedWindow("input-right",CV_WINDOW_AUTOSIZE);
  cvShowImage("input-right",src2);

  cvSaveImage(argv[3],output);
  cvWaitKey(0);
#else
  cvSaveImage(argv[3],output);
#endif

  cvReleaseImage(&src1);
  cvReleaseImage(&src2);
  cvReleaseImage(&output);

  return 0;
}
