#define _DEBUG
//#undef _DEBUG


#include <stdio.h>
#include<stdlib.h>
#include "graph.h"
#include<cv.h>
#include<highgui.h>
#include<cxcore.h>
#include <time.h>
#include<vector>

#define COST 1
#define HOGE COST
#define AREGION 255
#define BREGION 0

#define CONST 1
#define E 1000000000

#define HIDARI 0
#define UE 1
#define MIGI 2
#define SHITA 3

#define MAX_AB(a,b) ( (a) > (b) ? (a) : (b))
#define MUGEN 10000

using namespace std;

IplImage *left , *right;

typedef unsigned char uchar;
int k_height;
int k_width ;

int d_cost(int x,int y,int disp){//$B%G!<%?%3%9%H(B

  int sum = 0;
  int count = 0;

  int size_window = 1;

  for(int i = -size_window; i <= size_window; i++){
    for(int j = -size_window; j <= size_window; j++){
      if( ((x +j) > k_width) || ((x +j) < 0) ){continue;}
      if( ((y +i) > k_height) || ((y +i) < 0) ){continue;}
      count++;

      sum += abs(

		 ((uchar*)(left->imageData+left->widthStep*(y+i)))[(x+j)*3] - ((uchar*)(right->imageData+right->widthStep*(y+i)))[(x+j-disp)*3]
		 +
		 ((uchar*)(left->imageData+left->widthStep*(y+i)))[(x+j)*3+1] - ((uchar*)(right->imageData+right->widthStep*(y+i)))[(x+j-disp)*3+1]
		 +
		 ((uchar*)(left->imageData+left->widthStep*(y+i)))[(x+j)*3+2] - ((uchar*)(right->imageData+right->widthStep*(y+i)))[(x+j-disp)*3+2]

		 ) / 3;


    }
  }

  return sum / count;

}

int s_cost(uchar p, uchar q, int c){//$B%9%`!<%:%3%9%H(B

  return (int)( c * abs( int(p - q) ) );

}

inline int pixelIdx(int x, int y){//$B2hAG$N:BI8$+$i(Bnode$B$N(BIdx$B$r<hF@(B

  return ( (3*k_width-1)* y ) + ( 2 * x ); 

}

inline int pixelneighbor(int x, int y, int d){
  /* d$B$G;XDj2hAG$N$I$NJ}8~$K$"$k(Bnode$B$N(BIdx$B$rLa$jCM$H$9$k$+;XDj$9$k(B*/
  /* 0:$B:8!$(B1:$B>e!$(B2:$B1&!$(B3:$B2<(B*/

  switch(d){
  case 0:
    return ( pixelIdx(x,y)-1 );
    break;
  case 1:
    return ( pixelIdx(x,y) - (k_width + x));
    break;
  case 2:
    return ( pixelIdx(x,y)+1 );
    break;
  case 3:
    return ( pixelIdx(x,y) + ((2*k_width-1) - x) );
    break;
  default:
    return -1;
    break;
  }

}
int nearlabel(uchar label,std::vector<int>alpha,int maxdisp){

  int tmp;
  int min = maxdisp;
  int idx = 0;

  for(int i =0; i <alpha.size(); i++){

    tmp = abs(alpha[i] - label);

    // fprintf(stderr,"%d\n",tmp);

    if(min > tmp ){

      min = tmp;

      idx = i;

    }

  }

  return alpha[idx];
}

int main(int argc, char* argv[])
{

  clock_t start,end;

  start = clock();

  if(argc != 5){

    fprintf(stderr,"%s left_filename right_filename out_filename maxdisp\n",argv[0]);

    return -1;

  }


  int maxdisp = atoi(argv[4]);

  left = cvLoadImage(argv[1],CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);

  if(left == NULL){

    fprintf(stderr,"input left error\n");

    return -1;

  }

  right = cvLoadImage(argv[2],CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);

  if(right == NULL){

    fprintf(stderr,"input right error\n");

    return -1;

  }


  //////////////////////////////////
  // $B3,AX%0%i%U%+%C%HMQ;k:9G[Ns:n@.(B


  int n = maxdisp;

  int tmp = maxdisp;

  int count = 0;

  while(tmp != 1){

    tmp = tmp / 2;

    count++;

  }

  int a_size = ( count * 2 ) + 1;

  vector< vector<int> > a;

  a.resize(a_size);

  a[0].resize(1);

  a[1].resize(1);

  a[0][0] = 0;

  a[1][0] = n / 2;


  for(int k = 1; k < count; k++){

    int aa_size = (int)pow(2,(k-1)) ;

    a[2 * k].resize( aa_size );

    a[2 * k +1].resize( aa_size );

    for(int j = 0; j < aa_size; j++){

      a[2 * k][j] = ((1 + 4 * j) * n  / ( (int)pow(2, k+1) ) );

      a[2 * k +1][j] = ((3 + 4 * j) * n / ( (int)pow(2, k+1) ) );

    }


  }


  //$B3NG'MQ(B//

//   for(int i = 0 ; i < a.size() ; i++){

//     fprintf(stderr,"a[%d] = {",i);

//     for(int j = 0 ; j < a[i].size() ; j++){

//       fprintf(stderr,"%d,",a[i][j]);

//     }

//     fprintf(stderr,"}\n");

//   }

  // $B3,AX%0%i%U%+%C%HMQ;k:9G[Ns:n@.(B
  //////////////////////////////////


  int height = left->height;
  int width = left->width;

  k_height = left->height;
  k_width = left->width;


  int edge_num = ((height-1) *(width)) + ((height) * (width-1)) * 2;
  int node_num =  (width * height) 
    + ((width-1) * (height)) 
    + ((width) * (height-1));

  typedef Graph<int,int,int> GraphType;


  uchar f[width * height];
  uchar alpha[width * height];


  for(int p = 0; p < width * height; p++){//f$B$N=i4|CM$r@_Dj(B

    f[p] = 0;

  }


  int e = E;
  int success = 0;

  fprintf(stderr,"matching...\n");

  for(int n = 0; n < 1000; n++){

    success = 0;

    for(int al = 0; al < a.size(); al++){//alpha$B$NCM$rG[NsJ,2s$9(B
      //fprintf(stderr,"1\n");
      GraphType *g = new GraphType( node_num,  edge_num );//$B%0%i%U$N=i4|2=(B

      g -> add_node(node_num);//$B%N!<%I$NDI2C(B 


      /*$B%N!<%I$H%=!<%9!&%7%s%/$X$N=E$_$N@_Dj(B*/
      for(int j = 0; j < height; j++){
	for(int i = 0; i < width; i++){

	  int gaso_num = i + width*j;//$B2hAG:BI8$KBP1~$9$k0l<!85G[Ns$N(BIdx
	  int tmp_num = pixelIdx(i,j);//$B2hAG:BI8$KBP1~$9$k(Bnode$B$N(BIdx$B$r<hF@(B

	  alpha[gaso_num] = nearlabel( f[gaso_num], a[al] , maxdisp);

	  /*$B%G!<%?%3%9%H@_Dj(B*/
	  g -> add_tweights( tmp_num,d_cost(i , j , f[gaso_num]), 
			     d_cost(i , j , alpha[gaso_num]) );

	}

      }


      int omomi = 0;

      /*$B%(%C%8$N=E$_$r@_Dj(B*/
      for(int j = 0; j < height; j++){
	for(int i = 0; i < width; i++){
	  int epa,eap,eqa,eaq;
	  if( i != (width-1) ){//$B1&C<$O1&J}8~$X$N%(%C%8$,B8:_$7$J$$(B

	    if( s_cost( f[i+j*width], f[i+j*width +1], CONST) < s_cost( alpha[i+j*width], alpha[i+j*width +1], CONST)){

	      epa = MAX_AB( 0 , (s_cost(alpha[i+j*width], f[i+j*width +1], CONST) - s_cost( f[i+j*width], f[i+j*width +1], CONST) ) );
	      eap = MUGEN;
	      eqa = MAX_AB( 0 , (s_cost(alpha[i+j*width +1], f[i+j*width], CONST) - s_cost( f[i+j*width], f[i+j*width +1], CONST) ) );
	      eaq = MUGEN;

	    }else{

	      eap = MAX_AB( 0 , (s_cost(alpha[i+j*width +1], f[i+j*width], CONST) - s_cost( alpha[i+j*width], alpha[i+j*width +1], CONST) ) );
	      epa = MUGEN;
	      eaq = MAX_AB( 0 , (s_cost(alpha[i+j*width], f[i+j*width +1], CONST) - s_cost( alpha[i+j*width], alpha[i+j*width +1], CONST) ) );
	      eqa = MUGEN;

	    }



	    g -> add_edge( pixelIdx(i ,j),pixelneighbor(i,j,MIGI), epa, eap);
	    g -> add_edge( pixelneighbor(i,j,MIGI), pixelIdx(i+1 ,j),eaq, eqa );

	    //$BCf4V%N!<%I$N%7%s%/$H%=!<%9$X$N%3%9%H@_Dj!J1&!K(B
	    //$B%=!<%9B&!'(BV(fp,fq($B<!$N2hAG(B))
	    //$B%7%s%/B&!'(BV(alpha,alpha)
	    g -> add_tweights( pixelneighbor(i,j,MIGI),
			       s_cost(f[i+j*width],f[i+j*width +1],CONST), 
			       s_cost(alpha[i+j*width],alpha[i+j*width +1],CONST) );

	  }




	  if( j != (height-1) ){//$B2<C<$O2<J}8~$X$N%(%C%8$,B8:_$7$J$$(B

	    if( s_cost( f[i+j*width], f[i+(j+1)*width], CONST) < s_cost( alpha[i+j*width], alpha[i+(j+1)*width], CONST)){

	      epa = MAX_AB( 0 , (s_cost(alpha[i+j*width], f[i+(j+1)*width], CONST) - s_cost( f[i+j*width], f[i+(j+1)*width], CONST) ) );
	      eap = MUGEN;
	      eqa = MAX_AB( 0 , (s_cost(alpha[i+(j+1)*width], f[i+j*width], CONST) - s_cost( f[i+j*width], f[i+(j+1)*width], CONST) ) );
	      eaq = MUGEN;

	    }else{

	      eap = MAX_AB( 0 , (s_cost(alpha[i+(j+1)*width], f[i+j*width], CONST) - s_cost( alpha[i+j*width], alpha[i+(j+1)*width], CONST) ) );
	      epa = MUGEN;
	      eaq = MAX_AB( 0 , (s_cost(alpha[i+j*width], f[i+(j+1)*width], CONST) - s_cost( alpha[i+j*width], alpha[i+(j+1)*width], CONST) ) );
	      eqa = MUGEN;

	    }


	    g -> add_edge( pixelIdx(i ,j),pixelneighbor(i,j,SHITA), epa, eap);
	    g -> add_edge( pixelneighbor(i,j,SHITA), pixelIdx(i ,j +1),eaq, eqa );



	    //$BCf4V%N!<%I$N%7%s%/$H%=!<%9$X$N%3%9%H@_Dj!J2<!K(B
	    //$B%=!<%9B&!'(BV(fp,fq($B2<$N2hAG(B))
	    //$B%7%s%/B&!'(BV(alpha,alpha)
	    g -> add_tweights( pixelneighbor(i,j,SHITA),
			       s_cost(f[i+j*width],f[i+(j+1)*width],CONST), 
			       s_cost(alpha[i+j*width],alpha[i+(j+1)*width],CONST) );


	  }


	}
      }
 


      int flow = g -> maxflow();//$B:GBgN.!&:G>.%+%C%H%"%k%4%j%:%`E,MQ(B

      //fprintf(stderr,"%d %d\n",e,flow);

      if(flow < e){
	//fprintf(stderr,"Flow = %d\n", flow);

	/*$B8=:_$N%i%Y%k$r5a$^$C$?%i%Y%k$XJQ99(B*/
	for(int k =0; k < height ; k++){
	  for(int m =0; m < width ; m++){

	    int gaso_num = m + width*k;//$B2hAG:BI8$KBP1~$9$k0l<!85G[Ns$N(BIdx
	    int tmp_num = pixelIdx(m,k);//$B2hAG:BI8$KBP1~$9$k(Bnode$B$N(BIdx$B$r<hF@(B

	    if (g->what_segment(tmp_num) == GraphType::SOURCE){

	      f[gaso_num] = alpha[gaso_num];//$B%i%Y%k$r(Balpha$B$KJQ99(B

	    }else{

	      //$BJQ99$J$7(B

	    }

	  }

	}

	e = flow;
	success = 1;

      }
      delete g;


    }

    //fprintf(stderr,"roop = %d\n", n);
    if(success == 0){

      break;

    }

  }


  IplImage* output;
  output = cvCreateImage(cvGetSize(left),IPL_DEPTH_8U,1);
  for(int y = 0; y < output->height ; y++){

    for(int x = 0 ; x < output->width ; x++){

      ((uchar*)(output->imageData + output->widthStep * y))[x] = (uchar)(f[y * output->width + x] * 255.0 / maxdisp);

    }

  }

  end = clock();

  fprintf(stderr,"time = %f [s]\n",(double)(end - start) / CLOCKS_PER_SEC);


#ifdef _DEBUG
  cvNamedWindow("output",CV_WINDOW_AUTOSIZE);
  cvShowImage("output",output);
  cvNamedWindow("input_left",CV_WINDOW_AUTOSIZE);
  cvShowImage("input_left",left);
  cvNamedWindow("input_right",CV_WINDOW_AUTOSIZE);
  cvShowImage("input_right",right);

  cvWaitKey(0);

  cvSaveImage(argv[3],output);
#endif

  cvReleaseImage(&left);
  cvReleaseImage(&right);
  cvReleaseImage(&output);

  return 0;
}

